##script apxprint_cpp;
##begin
//----------------------------------------------------------------------------
//  Project @Project@
//  @CompanyName@
//  @Copyright@
//
//  SUBSYSTEM:    @Target@ Application
//  FILE:         apxprint.cpp
//  AUTHOR:       @Author@
//
//  OVERVIEW
//  ~~~~~~~~
//  Source file for implementation of Printing.
//  (Generated by OWL 6.x Wizard for MS VC++. Version 1.5)
//----------------------------------------------------------------------------
#include "owlpch.h"
#include "apxprint.h"


##if @OPT_APPL_COMMENT@ begin
// Do not enable page range in the print dialog since only one page is
// available to be printed
//
##end // OPT_APPL_COMMENT
void TApxPrintout::GetDialogInfo(int& minPage, int&, int& selFromPage, int&)
{
  minPage = 1;
  selFromPage = 0;
}


void TApxPrintout::BeginPrinting()
{
  TRect clientR;

  BeginPage(clientR);

  HFONT   hFont = (HFONT)Window->GetWindowFont();
  TFont   font(_T("Arial"), -12);
  if (!hFont)
    DC->SelectObject(font);
  else
    DC->SelectObject(TFont(hFont));

  TEXTMETRIC  tm;
  int fHeight = DC->GetTextMetrics(tm) ? tm.tmHeight + tm.tmExternalLeading : 10;

  DC->RestoreFont();

##if @OPT_APPL_COMMENT@ begin
  // How many lines of this font can we fit on a page.
  //
##end // OPT_APPL_COMMENT
  int linesPerPage = MulDiv(clientR.Height(), 1, fHeight);

  TPrintDialog::TData& printerData = Printer->GetSetup();

##if @OPT_APPL_COMMENT@ begin
  // GetMinMaxInfo event is overrided to return the number of lines when printing.
  //
##end // OPT_APPL_COMMENT
  MINMAXINFO minmaxinfo;
  Window->SendMessage(WM_GETMINMAXINFO, 0, (long)&minmaxinfo);
  int maxPg = (minmaxinfo.ptMaxSize.y / linesPerPage) + 1.0;

##if @OPT_APPL_COMMENT@ begin
  // Compute the number of pages to print.
  //
##end // OPT_APPL_COMMENT
  printerData.MinPage = 1;
  printerData.MaxPage = maxPg;

  EndPage();

  TPrintout::BeginPrinting();
}


void TApxPrintout::BeginPage(TRect& clientR)
{
  TScreenDC screenDC;
  TSize screenRes(screenDC.GetDeviceCaps(LOGPIXELSX),
          screenDC.GetDeviceCaps(LOGPIXELSY));
  TSize printRes(DC->GetDeviceCaps(LOGPIXELSX),
           DC->GetDeviceCaps(LOGPIXELSY));

##if @OPT_APPL_COMMENT@ begin
  // Temporarily change the window size (so any WM_PAINT queries on the total window size (GetClientRect) is
  // the window size for the WM_PAINT of the window and the printer page size when Paint is called from
  // PrintPage. Notice, we don't use AdjustWindowRect because its harder and not accurate.  Instead we
  // compute the difference (in pixels) between the client window and the frame window.  This difference
  // is then added to the clientRect to compute the new frame window size for SetWindowPos.
  //
##end // OPT_APPL_COMMENT
  clientR = Window->GetClientRect();
  Window->MapWindowPoints(HWND_DESKTOP, (TPoint*)&clientR, 2);

##if @OPT_APPL_COMMENT@ begin
  // Compute extra X and Y pixels to bring a client window dimensions to equal the frame window.
  //
##end // OPT_APPL_COMMENT
  OrgR = Window->GetWindowRect();
  int adjX = OrgR.Width() - clientR.Width();
  int adjY = OrgR.Height() - clientR.Height();

##if @OPT_APPL_COMMENT@ begin
  // Conditionally scale the DC to the window so the printout will resemble the window.
  //
##end // OPT_APPL_COMMENT
  if (Scale) {
    clientR = Window->GetClientRect();
    PrevMode = DC->SetMapMode(MapMode);
    DC->SetViewportExt(PageSize, &OldVExt);

##if @OPT_APPL_COMMENT@ begin
    // Scale window to logical page size (assumes left & top are 0)
    //
##end // OPT_APPL_COMMENT
    clientR.right = MulDiv(PageSize.cx, screenRes.cx, printRes.cx);
    clientR.bottom = MulDiv(PageSize.cy, screenRes.cy, printRes.cy);

    DC->SetWindowExt(clientR.Size(), &OldWExt);
  }

##if @OPT_APPL_COMMENT@ begin
  // Compute the new size of the window based on the printer DC dimensions.
  // Resize the window, notice position, order, and redraw are not done the window size changes but the user
  // doesn't see any visible change to the window.
  //
##end // OPT_APPL_COMMENT
  Window->SetRedraw(false);
  Window->SetWindowPos(0, 0, 0, clientR.Width() + adjX, clientR.Height() + adjY,
                       SWP_NOMOVE | SWP_NOREDRAW | SWP_NOZORDER| SWP_NOACTIVATE);
}


void TApxPrintout::PrintPage(int page, TRect& bandRect, unsigned)
{
  TRect clientR;

  BeginPage(clientR);

  if (Scale)
    DC->DPtoLP(bandRect, 2);

##if @OPT_APPL_COMMENT@ begin
  // Change the printer range to this current page.
  //
##end // OPT_APPL_COMMENT
  TPrintDialog::TData& printerData = Printer->GetSetup();
  int fromPg = printerData.FromPage;
  int toPg = printerData.ToPage;

  printerData.FromPage = page;
  printerData.ToPage = page;

##if @OPT_APPL_COMMENT@ begin
  // Call the window to paint itself to the printer DC.
  //
##end // OPT_APPL_COMMENT
  Window->Paint(*DC, false, bandRect);

  printerData.FromPage = fromPg;
  printerData.ToPage = toPg;

  if (Scale)
    DC->LPtoDP(bandRect, 2);

  EndPage();
}


void TApxPrintout::EndPage()
{
##if @OPT_APPL_COMMENT@ begin
  // Resize to original window size, no one's the wiser.
  //
##end // OPT_APPL_COMMENT
  Window->SetWindowPos(0, 0, 0, OrgR.Width(), OrgR.Height(),
               SWP_NOMOVE | SWP_NOREDRAW | SWP_NOZORDER| SWP_NOACTIVATE);
  Window->SetRedraw(true);

##if @OPT_APPL_COMMENT@ begin
  // Restore changes made to the DC
  //
##end // OPT_APPL_COMMENT
  if (Scale) {
    DC->SetWindowExt(OldWExt);
    DC->SetViewportExt(OldVExt);
    DC->SetMapMode(PrevMode);
  }
}


bool TApxPrintout::HasPage(int pageNumber)
{
  TPrintDialog::TData& printerData = Printer->GetSetup();

  return pageNumber >= printerData.MinPage && pageNumber <= printerData.MaxPage;
}


##end.
